import * as unplugin_combine_dist_types_js from 'unplugin-combine/dist/types.js';
import { Options as Options$1 } from '@vue-macros/better-define';
import { Options as Options$2 } from '@vue-macros/define-model';
import { Options as Options$3 } from 'unplugin-vue-define-options';
import { Options as Options$4 } from '@vue-macros/define-props';
import { Options as Options$5 } from '@vue-macros/define-props-refs';
import { Options as Options$6 } from '@vue-macros/define-render';
import { Options as Options$7 } from '@vue-macros/define-slots';
import { Options as Options$8 } from '@vue-macros/export-props';
import { Options as Options$9 } from '@vue-macros/hoist-static';
import { Options as Options$a } from '@vue-macros/named-template';
import { Options as Options$b } from '@vue-macros/reactivity-transform';
import { Options as Options$c } from '@vue-macros/setup-block';
import { Options as Options$d } from '@vue-macros/setup-component';
import { Options as Options$e } from '@vue-macros/setup-sfc';
import { Options as Options$f } from '@vue-macros/short-emits';
import { Options as Options$g } from '@vue-macros/single-define';

interface FeatureOptionsMap {
    betterDefine: Options$1;
    defineModel: Options$2;
    defineOptions: Options$3;
    defineProps: Options$4;
    definePropsRefs: Options$5;
    defineRender: Options$6;
    defineSlots: Options$7;
    exportProps: Options$8;
    hoistStatic: Options$9;
    namedTemplate: Options$a;
    reactivityTransform: Options$b;
    setupBlock: Options$c;
    setupComponent: Options$d;
    setupSFC: Options$e;
    shortEmits: Options$f;
    singleDefine: Options$g;
}
type FeatureName = keyof FeatureOptionsMap;
type FeatureOptions = FeatureOptionsMap[FeatureName];
interface OptionsCommon {
    root?: string;
    version?: 2 | 3;
    isProduction?: boolean;
    plugins?: {
        vue?: any;
        vueJsx?: any;
    };
    /** @internal */
    nuxtContext?: {
        isClient?: boolean;
    };
}
type OptionalSubOptions<T> = boolean | Omit<T, keyof OptionsCommon> | undefined;
type Options = OptionsCommon & {
    [K in FeatureName]?: OptionalSubOptions<FeatureOptionsMap[K]>;
};
type OptionsResolved = Required<OptionsCommon> & {
    [K in FeatureName]: false | FeatureOptionsMap[K];
};
declare const _default: unplugin_combine_dist_types_js.UnpluginCombineInstance<Options | undefined>;

export { FeatureName, FeatureOptions, FeatureOptionsMap, Options, OptionsCommon, OptionsResolved, _default as default };
